// Scan I2C bus for device responses
/*
#define SDA_PORT PORTD
//#define SDA_PIN 3
#define SCL_PORT PORTD
#define SCL_PIN 5
*/
#define I2C_TIMEOUT 100
#define I2C_NOINTERRUPT 0
#define I2C_SLOWMODE 1
#define FAC 1
#define I2C_CPUFREQ (F_CPU/FAC)


// Corresponds to A4/A5 - the hardware I2C pins on Arduinos
#define SDA_PORT PORTC
#define SDA_PIN 4
#define SCL_PORT PORTC
#define SCL_PIN 5
#define I2C_FASTMODE 1

#define LED_RED 2       //赤LEDピン
#define LED_BLUE 3      //青LEDピン

#include <SoftI2CMaster.h>
#include <avr/io.h>

//------------------------------------------------------------------------------
void CPUSlowDown(int fac) {
  // slow down processor by a fac
    CLKPR = _BV(CLKPCE);
    CLKPR = _BV(CLKPS1) | _BV(CLKPS0);
}

const byte kimochi[] = {
    '0','1','1','1','1','1','2','2','2','2',       //0-9
    '2','1','1','1','1','1','1','1','1','1',       //10-19
    '1','1','1','1','2','1','1','1','4','1',       //20-29
    '1','1','1','1','1','1','1','3','3','2',       //30-39
    '2','2','1','0','0','0','0','0','0','0',       //40-49
    '1','1','1','1','1','1','1','1','1','1',       //50-59
    '1','1','1','1','1','1','1','1','1','1',       //60-69
    '1','1','1','1','1','1','1','1','1','1',       //70-79
    '1','2','1','1','1','2','2','2','2','2',       //80-89
    '2','2','2','2','2','2','4','4','4','4',       //90-99
    '4','4','4','4','1','1','1','2','4','3',       //100-109
    '3','2','3','3','1','1','2','2','4','4',       //110-119
    '1','1','3','2','2','4','4','4','4','2',       //120-129
    '1','1','1','1','1','1','1','1','1','1',       //130-139
    '1','1','2','2','2','2','1','1','1','1',       //140-149
    '1','1','1','0','0','0','0','0','0','0',       //150-159
    '2','2','2','2','2','2','2','2','2','1',       //160-169
    '1','1','1','1','1','1','1','2','2','2',       //170-179
    '2','2','1','1','1','2','2','2','1','1',       //180-189
    '1','1','1','1','1','2','2','1','1','2',       //190-199
    '2','2','2','2','2','2','1','1','4','3',       //200-209
    '2','2','2','2','2','2','1','3','1','1',       //210-219
    '1','3','2','2','2','1','1','1','1','1',       //220-229
    '1','1','2','2','2','2','2','2','2','3',       //230-239
    '1','1','0','0','0','0','0','2','3','3',       //240-249
    '3','1','1','1','1','1','1','2','2','1',       //250-259
    '1','1','2','1','1','1','1','2','3','0',       //260-269
    '0','2','2','3','3','1','4'};                  //270-276                   
void setup(void) {
#if FAC != 1
  CPUSlowDown(FAC);
#endif
  pinMode(LED_RED, OUTPUT);
  pinMode(LED_BLUE, OUTPUT);
  delay(5000);  //ロビの起動を待たせる
}

uint8_t dt = 0;
//uint8_t dt1 = 0;
int id = 0;
int prev_id = 0;

void loop(void)
{
  uint8_t i2c_adr = 80;
  uint8_t reg_adr = 33;

    if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
          if (i2c_write(reg_adr)) {               // レジスタアドレスを指定
               if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                     dt = i2c_read(true);
                     id = (int) dt;
                     if (id <= 20)
                      {
                         i2c_stop() ;                                   // ストップコンディションを発行する
                          if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
                                if (i2c_write(reg_adr - 1)) {               // レジスタアドレスを指定
                                     if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                                      dt = i2c_read(true);
                                         if (dt == 1)
                                          id += 256;
                                     }
                                }
                             }
                       } 
                     if (id != prev_id)
                     {
                                      
                       if (kimochi[id] == '1') 
                       {
                            digitalWrite(LED_RED, LOW);
                            digitalWrite(LED_BLUE, HIGH);
                       }
                       else if (kimochi[id] == '2') 
                       {
                            digitalWrite(LED_RED, HIGH);
                            digitalWrite(LED_BLUE, LOW);
                       }       
                       else if (kimochi[id] == '3') 
                       {
                            digitalWrite(LED_RED, HIGH);
                            digitalWrite(LED_BLUE, HIGH);
                       } 
                       else if (kimochi[id] == '4') 
                       {
                            digitalWrite(LED_RED, LOW);
                            digitalWrite(LED_BLUE, LOW);
                       } 
                 }
              }
          }
     }
     i2c_stop() ;                                   // ストップコンディションを発行する
     delay(500);
}
